<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit();
}

class VIWCAIO_CART_ALL_IN_ONE_Frontend_Sidebar_Cart_Content {
	protected $settings, $sc_checkout, $language;
	protected $is_customize, $customize_data;
	public function __construct() {
		$this->settings    = new VIWCAIO_CART_ALL_IN_ONE_DATA();
		$this->sc_checkout = $this->settings->enable( 'sc_checkout_' );
		add_action( 'wp_enqueue_scripts', array( $this, 'viwcaio_wp_enqueue_scripts' ) );
		if ( $this->sc_checkout ) {
			add_action( 'template_redirect', array( $this, 'init_payment_gateways' ) );
			add_action( 'wp_enqueue_scripts', array( $this, 'remove_filter_is_checkout' ), 11 );
			add_filter( 'woocommerce_update_order_review_fragments', array( 'VIWCAIO_CART_ALL_IN_ONE_Frontend_Form_Checkout', 'viwcaio_woocommerce_update_order_review_fragments' ), PHP_INT_MAX, 1 );
			add_filter( 'wc_square_credit_card_payment_form_js_args', array( 'VIWCAIO_CART_ALL_IN_ONE_Frontend_Form_Checkout', 'viwcaio_wc_square_credit_card_payment_form_js_args' ), PHP_INT_MAX, 2 );
			if (is_plugin_active('flexible-checkout-fields/flexible-checkout-fields.php')||is_plugin_active('flexible-checkout-fields-pro/flexible-checkout-fields-pro.php')){
				add_action( 'wp_footer', array( $this, 'add_filter_is_checkout' ) );
				add_action( 'wp_footer', array( $this, 'remove_filter_is_checkout' ), 11 );
            }
		}
		add_action( 'vi_wcaio_get_sidebar_cart_content', array( $this, 'get_sidebar_cart_content' ) );
		add_action( 'vi_wcaio_sc_pd_plus_simple_atc', array( $this, 'get_pd_plus_simple_atc' ), 10, 3 );
		add_action( 'vi_wcaio_sc_pd_plus_external_atc', array( $this, 'get_pd_plus_external_atc' ), 10, 3 );
		add_action( 'vi_wcaio_sc_pd_plus_grouped_atc', array( $this, 'get_pd_plus_grouped_atc' ), 10, 3 );
		add_action( 'vi_wcaio_sc_pd_plus_variable_atc', array( $this, 'get_pd_plus_grouped_atc' ), 10, 3 );
	}
	public function viwcaio_wp_enqueue_scripts(){
		if ( is_checkout() || is_cart() ) {
			return;
		}
		$this->is_customize = is_customize_preview();
		if ( ! $this->is_customize && ! $this->assign_page() ) {
			return;
		} else {
			global $wp_customize;
			$this->customize_data = $wp_customize;
		}
		$sc_footer_message = $this->settings->get_params( 'sc_footer_message' );
		$has_product_plus  = strpos( $sc_footer_message, '{product_plus}' );
		wp_enqueue_style( 'vi-wcaio-loading', VIWCAIO_CART_ALL_IN_ONE_CSS . 'loading.min.css', array(), VIWCAIO_CART_ALL_IN_ONE_VERSION );
		$suffix = WP_DEBUG ? '' : 'min.';
		wp_enqueue_style( 'vi-wcaio-sidebar-cart-content', VIWCAIO_CART_ALL_IN_ONE_CSS . 'sidebar-cart-content.' . $suffix . 'css', array(), VIWCAIO_CART_ALL_IN_ONE_VERSION );
		wp_enqueue_script( 'vi-wcaio-sidebar-cart', VIWCAIO_CART_ALL_IN_ONE_JS . 'sidebar-cart.' . $suffix . 'js', array( 'jquery' ), VIWCAIO_CART_ALL_IN_ONE_VERSION );
		if ( ( $has_product_plus !== false ) || $this->is_customize ) {
			wp_enqueue_style( 'vi-wcaio-cart-icons-atc', VIWCAIO_CART_ALL_IN_ONE_CSS . 'cart-icons-atc.min.css', array(), VIWCAIO_CART_ALL_IN_ONE_VERSION );
			wp_enqueue_style( 'vi-wcaio-nav-icons', VIWCAIO_CART_ALL_IN_ONE_CSS . 'nav-icons.min.css', array(), VIWCAIO_CART_ALL_IN_ONE_VERSION );
			wp_enqueue_style( 'vi-wcaio-flexslider', VIWCAIO_CART_ALL_IN_ONE_CSS . 'sc-flexslider.min.css', array(), VIWCAIO_CART_ALL_IN_ONE_VERSION );
			wp_enqueue_script( 'vi-wcaio-flexslider', VIWCAIO_CART_ALL_IN_ONE_JS . 'vi-flexslider.min.js', array( 'jquery' ), VIWCAIO_CART_ALL_IN_ONE_VERSION );
		}
		if ( $this->sc_checkout || $this->is_customize ) {
			wp_enqueue_style( 'vi-wcaio-back-icons', VIWCAIO_CART_ALL_IN_ONE_CSS . 'back-icons.min.css', array(), VIWCAIO_CART_ALL_IN_ONE_VERSION );
			if ( wp_style_is( 'woocommerce-general', 'registered' ) ) {
				wp_enqueue_style( 'vi-wcaio-sc-checkout', VIWCAIO_CART_ALL_IN_ONE_CSS . 'sc-checkout.min.css', array( 'select2', 'woocommerce-general' ), VIWCAIO_CART_ALL_IN_ONE_VERSION );
			} else {
				wp_enqueue_style( 'vi-wcaio-sc-checkout', VIWCAIO_CART_ALL_IN_ONE_CSS . 'sc-checkout.min.css', array( 'select2' ), VIWCAIO_CART_ALL_IN_ONE_VERSION );
			}
			wp_enqueue_script( 'vi-wcaio-selectWoo', VIWCAIO_CART_ALL_IN_ONE_JS . 'vi-selectWoo.' . $suffix . 'js', array( 'jquery' ), VIWCAIO_CART_ALL_IN_ONE_VERSION );
			wp_enqueue_script( 'vi-wcaio-sc-checkout', VIWCAIO_CART_ALL_IN_ONE_JS . 'sc-checkout.' . $suffix . 'js', array( 'jquery', 'wc-checkout' ), VIWCAIO_CART_ALL_IN_ONE_VERSION, true );
			$checkout_args = array(
				'invalid_text'              => apply_filters( 'vi-wcaio-invalid_text', __( 'Please insert all required information to checkout.', 'woocommerce-cart-all-in-one' ) ),
				'unavailable_checkout_text' => apply_filters( 'vi-wcaio-unavailable_checkout_text', __( 'Checkout is not available whilst your cart is empty.', 'woocommerce-cart-all-in-one' ) )
			);
			if ( $this->sc_checkout ) {
				if ( wp_script_is( 'alg-payment-gateways-checkout', 'registered' ) ) {
					wp_enqueue_script( 'alg-payment-gateways-checkout' );
				}
				$filters = array(
					'woocommerce_is_checkout' => 'viwcaio_is_checkout',
					'viwcuf_ob_enable'        => 'viwcaio_is_not_checkout',
					'viwcuf_us_enable'        => 'viwcaio_is_not_checkout',
				);
				foreach ( $filters as $k => $v ) {
					add_filter( $k, array( 'VIWCAIO_CART_ALL_IN_ONE_Frontend_Form_Checkout', $v ), PHP_INT_MAX, 1 );
				}
				add_filter( 'yith_ppec_show_button_everywhere', array( 'VIWCAIO_CART_ALL_IN_ONE_Frontend_Form_Checkout', 'viwcaio_is_checkout' ), PHP_INT_MAX, 1 );
				if (class_exists('WC_Gateway_Twocheckout') ){
					$checkout_args['WC_Gateway_Twocheckout'] =array(
						'twocheckoutIsCheckout' => ( is_checkout() && empty( $_GET['pay_for_order'] ) ) ? 'yes' : 'no'
					);
					if (WC()->cart->is_empty()){
					    $checkout_args['WC_Gateway_Twocheckout']['not_twocheckoutIsCheckout'] = 1;
						wp_enqueue_script( '2payjs', 'https://2pay-js.2checkout.com/v1/2pay.js' );
						wp_enqueue_script( 'twocheckout_script', '/wp-content/plugins/twocheckout/assets/js/twocheckout.js' );
						wp_enqueue_style( 'twocheckout_style', '/wp-content/plugins/twocheckout/assets/css/twocheckout.css' );
                    }
				}
				if (class_exists('WC_Gateway_Twocheckout_Inline') ){
					$checkout_args['WC_Gateway_Twocheckout_Inline'] =1;
				}
				$checkout_args['country_locale'] =  wp_json_encode( WC()->countries->get_country_locale() );
			}
			wp_localize_script( 'vi-wcaio-sc-checkout', 'viwcaio_sc_checkout_params', $checkout_args);
		}
		if ( ! $this->is_customize ) {
			if ( is_plugin_active( 'sitepress-multilingual-cms/sitepress.php' ) ) {
				$default_lang     = apply_filters( 'wpml_default_language', null );
				$current_language = apply_filters( 'wpml_current_language', null );
				if ( $current_language && $current_language !== $default_lang ) {
					$this->language = '_' . $current_language;
				}
			} else if ( class_exists( 'Polylang' ) ) {
				$default_lang     = pll_default_language( 'slug' );
				$current_language = pll_current_language( 'slug' );
				if ( $current_language && $current_language !== $default_lang ) {
					$this->language = '_' . $current_language;
				}
			}
			$args = array(
				'wc_ajax_url'                      => WC_AJAX::get_endpoint( "%%endpoint%%" ),
				'language'                         => $this->language,
				'sc_content_class_open' => $this->settings->get_params( 'sc_content_class_open' ) ?: '',
				'update_cart_when_changing_pd_qty' => $this->settings->get_params( 'sc_pd_update_cart' ) ?: '',
			);
			wp_localize_script( 'vi-wcaio-sidebar-cart', 'viwcaio_sc_params', $args );
			$css = $this->get_inline_css();
			wp_add_inline_style( 'vi-wcaio-sidebar-cart-content', $css );
			if ( $has_product_plus !== false ) {
				wp_enqueue_script( 'vi-wcaio-ajax-atc', VIWCAIO_CART_ALL_IN_ONE_JS . 'ajax-add-to-cart.' . $suffix . 'js', array( 'jquery' ), VIWCAIO_CART_ALL_IN_ONE_VERSION );
				$args1 = array(
					'ajax_atc'                            => $this->settings->get_params( 'ajax_atc' ),
					'wc_ajax_url'                         => WC_AJAX::get_endpoint( "%%endpoint%%" ),
					'woocommerce_enable_ajax_add_to_cart' => 'yes' === get_option( 'woocommerce_enable_ajax_add_to_cart' ) ? 1 : '',
					'added_to_cart'                       => did_action( 'woocommerce_add_to_cart' ) ?: '',
					'ajax_atc_pd_exclude'                 => $this->settings->get_params( 'ajax_atc_pd_exclude' ) ?: array(),
					'i18n_make_a_selection_text'          => apply_filters( 'vi-wcaio-i18n_make_a_selection_text', __( 'Please select some product options before adding this product to your cart.', 'woocommerce-cart-all-in-one' ) ),
					'i18n_unavailable_text'               => apply_filters( 'vi-wcaio-i18n_unavailable_text', __( 'Sorry, this product is unavailable. Please choose a different combination.', 'woocommerce-cart-all-in-one' ) ),
					'cart_url'                            => apply_filters( 'woocommerce_add_to_cart_redirect', wc_get_cart_url(), null ),
					'cart_redirect_after_add'             => get_option( 'woocommerce_cart_redirect_after_add' ),
				);
				wp_localize_script( 'vi-wcaio-ajax-atc', 'viwcaio_ajax_atc_params', $args1 );
			}
		}
		add_action( 'wp_footer', array( $this, 'frontend_html' ) );
	}
	public function get_checkout_inline_css($frontend) {
		$css      = '';
		$frontend = $frontend ?: 'VIWCAIO_CART_ALL_IN_ONE_Frontend_Frontend';
		$css      .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-content-wrap1.vi-wcaio-sidebar-cart-checkout-wrap' ),
			array( 'sc_checkout_bg_color' ),
			array( 'background' ),
			array( '' )
		);
		$css      .= $frontend::add_inline_style(
			array(
			        '.vi-wcaio-sidebar-cart button.vi-wcaio-sidebar-cart-bt-checkout-cancel',
			        '.vi-wcaio-sidebar-cart .button.vi-wcaio-sidebar-cart-bt-checkout-cancel'
            ),
			array( 'sc_checkout_bt_btc_bg_color', 'sc_checkout_bt_btc_color', 'sc_checkout_bt_btc_border_radius' ),
			array( 'background', 'color', 'border-radius' ),
			array( '', '', 'px' )
		);
		$css      .= $frontend::add_inline_style(
			array(
			        '.vi-wcaio-sidebar-cart button.vi-wcaio-sidebar-cart-bt-checkout-cancel:hover' ,
			        '.vi-wcaio-sidebar-cart .button.vi-wcaio-sidebar-cart-bt-checkout-cancel:hover'
            ),
			array( 'sc_checkout_bt_btc_hover_bg_color', 'sc_checkout_bt_btc_hover_color' ),
			array( 'background', 'color' ),
			array( '', '' )
		);
		$css      .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .button.vi-wcaio-sidebar-cart-bt-checkout-nav.vi-wcaio-sidebar-cart-bt-checkout-next' ),
			array( 'sc_checkout_bt_next_bg_color', 'sc_checkout_bt_next_color', 'sc_checkout_bt_next_border_radius' ),
			array( 'background', 'color', 'border-radius' ),
			array( '', '', 'px' )
		);
		$css      .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .button.vi-wcaio-sidebar-cart-bt-checkout-nav.vi-wcaio-sidebar-cart-bt-checkout-next:hover' ),
			array( 'sc_checkout_bt_next_hover_bg_color', 'sc_checkout_bt_next_hover_color' ),
			array( 'background', 'color' ),
			array( '', '' )
		);
		$css      .= $frontend::add_inline_style(
			array(
			        '.vi-wcaio-sidebar-cart button.vi-wcaio-sidebar-cart-bt-checkout-nav.vi-wcaio-sidebar-cart-bt-checkout-back',
			        '.vi-wcaio-sidebar-cart .button.vi-wcaio-sidebar-cart-bt-checkout-nav.vi-wcaio-sidebar-cart-bt-checkout-back'
            ),
			array( 'sc_checkout_bt_pre_bg_color', 'sc_checkout_bt_pre_color', 'sc_checkout_bt_pre_border_radius' ),
			array( 'background', 'color', 'border-radius' ),
			array( '', '', 'px' )
		);
		$css      .= $frontend::add_inline_style(
			array(
			        '.vi-wcaio-sidebar-cart button.vi-wcaio-sidebar-cart-bt-checkout-nav.vi-wcaio-sidebar-cart-bt-checkout-back:hover',
			        '.vi-wcaio-sidebar-cart .button.vi-wcaio-sidebar-cart-bt-checkout-nav.vi-wcaio-sidebar-cart-bt-checkout-back:hover',
            ),
			array( 'sc_checkout_bt_pre_hover_bg_color', 'sc_checkout_bt_pre_hover_color' ),
			array( 'background', 'color' ),
			array( '', '' )
		);
		$css      .= $frontend::add_inline_style(
			array(
			        '.vi-wcaio-sidebar-cart button.vi-wcaio-sidebar-cart-bt-checkout-place_order',
			        '.vi-wcaio-sidebar-cart .button.vi-wcaio-sidebar-cart-bt-checkout-place_order',
            ),
			array( 'sc_checkout_bt_place_order_bg_color', 'sc_checkout_bt_place_order_color', 'sc_checkout_bt_place_order_border_radius' ),
			array( 'background', 'color', 'border-radius' ),
			array( '', '', 'px' )
		);
		$css      .= $frontend::add_inline_style(
			array(
			        '.vi-wcaio-sidebar-cart button.vi-wcaio-sidebar-cart-bt-checkout-place_order:hover',
			        '.vi-wcaio-sidebar-cart .button.vi-wcaio-sidebar-cart-bt-checkout-place_order:hover',
            ),
			array( 'sc_checkout_bt_place_order_hover_bg_color', 'sc_checkout_bt_place_order_hover_color' ),
			array( 'background', 'color' ),
			array( '', '' )
		);
		$css      .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart-wrap .vi-wcaio-checkout-nav-step-wrap .vi-wcaio-checkout-nav-step' ),
			array( 'sc_checkout_nav_bar_color' ),
			array( 'background' ),
			array( '' )
		);
		$css      .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart-wrap .vi-wcaio-checkout-nav-step-wrap .vi-wcaio-checkout-nav-step:hover' ),
			array( 'sc_checkout_nav_bar_hover_color' ),
			array( 'background' ),
			array( '' )
		);
		$css      .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart-wrap .vi-wcaio-checkout-nav-step-wrap .vi-wcaio-checkout-nav-step.vi-wcaio-checkout-step-current' ),
			array( 'sc_checkout_nav_bar_selected_color' ),
			array( 'background' ),
			array( '' )
		);
		return $css;
	}
	public function get_inline_css() {
		$css = '';
		$frontend = 'VIWCAIO_CART_ALL_IN_ONE_Frontend_Frontend';
		if ( $this->settings->enable( 'sc_checkout_' ) ) {
			$css .= $this->get_checkout_inline_css($frontend);
		}
		if ( $sc_horizontal = $this->settings->get_params( 'sc_horizontal' ) ) {
			$sc_horizontal_mobile = $sc_horizontal > 20 ? 20 - $sc_horizontal : 0;
			$css                  .= '.vi-wcaio-sidebar-cart.vi-wcaio-sidebar-cart-1.vi-wcaio-sidebar-cart-top_left,
            .vi-wcaio-sidebar-cart.vi-wcaio-sidebar-cart-1.vi-wcaio-sidebar-cart-bottom_left{
                left: ' . $sc_horizontal . 'px ;
            }
            .vi-wcaio-sidebar-cart.vi-wcaio-sidebar-cart-1.vi-wcaio-sidebar-cart-top_right,
            .vi-wcaio-sidebar-cart.vi-wcaio-sidebar-cart-1.vi-wcaio-sidebar-cart-bottom_right{
                right: ' . $sc_horizontal . 'px ;
            }
            @media screen and (max-width: 768px) {
                .vi-wcaio-sidebar-cart.vi-wcaio-sidebar-cart-1.vi-wcaio-sidebar-cart-top_left .vi-wcaio-sidebar-cart-content-wrap,
                .vi-wcaio-sidebar-cart.vi-wcaio-sidebar-cart-1.vi-wcaio-sidebar-cart-bottom_left .vi-wcaio-sidebar-cart-content-wrap{
                    left: ' . $sc_horizontal_mobile . 'px ;
                }
                .vi-wcaio-sidebar-cart.vi-wcaio-sidebar-cart-1.vi-wcaio-sidebar-cart-top_right .vi-wcaio-sidebar-cart-content-wrap,
                .vi-wcaio-sidebar-cart.vi-wcaio-sidebar-cart-1.vi-wcaio-sidebar-cart-bottom_right .vi-wcaio-sidebar-cart-content-wrap{
                    right: ' . $sc_horizontal_mobile . 'px ;
                }
            }
            ';
		}
		if ( $sc_vertical = $this->settings->get_params( 'sc_vertical' ) ) {
			$sc_vertical_mobile = $sc_vertical > 20 ? 20 - $sc_vertical : 0;
			$css                .= '.vi-wcaio-sidebar-cart.vi-wcaio-sidebar-cart-1.vi-wcaio-sidebar-cart-top_left,
            .vi-wcaio-sidebar-cart.vi-wcaio-sidebar-cart-1.vi-wcaio-sidebar-cart-top_right{
                top: ' . $sc_vertical . 'px ;
            }
            .vi-wcaio-sidebar-cart.vi-wcaio-sidebar-cart-1.vi-wcaio-sidebar-cart-bottom_right,
            .vi-wcaio-sidebar-cart.vi-wcaio-sidebar-cart-1.vi-wcaio-sidebar-cart-bottom_left{
                bottom: ' . $sc_vertical . 'px ;
            }
            @media screen and (max-width: 768px) {
                .vi-wcaio-sidebar-cart.vi-wcaio-sidebar-cart-1.vi-wcaio-sidebar-cart-top_left .vi-wcaio-sidebar-cart-content-wrap,
                .vi-wcaio-sidebar-cart.vi-wcaio-sidebar-cart-1.vi-wcaio-sidebar-cart-top_right .vi-wcaio-sidebar-cart-content-wrap{
                    top: ' . $sc_vertical_mobile . 'px ;
                }
                .vi-wcaio-sidebar-cart.vi-wcaio-sidebar-cart-1.vi-wcaio-sidebar-cart-bottom_right .vi-wcaio-sidebar-cart-content-wrap,
                .vi-wcaio-sidebar-cart.vi-wcaio-sidebar-cart-1.vi-wcaio-sidebar-cart-bottom_left .vi-wcaio-sidebar-cart-content-wrap{
                    bottom: ' . $sc_vertical_mobile . 'px ;
                }
            }';
		}
		if ( $sc_loading_color = $this->settings->get_params( 'sc_loading_color' ) ) {
			$css .= '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-loading-dual_ring:after {
                border-color: ' . $sc_loading_color . '  transparent <?php echo esc_html($sc_loading_color); ?>  transparent;
            }
            .vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-loading-ring div{
                border-color: ' . $sc_loading_color . '  transparent transparent transparent;
            }
            .vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-loading-ripple  div{
                border: 4px solid ' . $sc_loading_color . ' ;
            }
            .vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-loading-default div,
            .vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-loading-animation_face_1 div,
            .vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-loading-animation_face_2 div,
            .vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-loading-roller div:after,
            .vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-loading-loader_balls_1 div,
            .vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-loading-loader_balls_2 div,
            .vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-loading-loader_balls_3 div,
            .vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-loading-spinner div:after{
                background: ' . $sc_loading_color . ' ;
            }';
		}
		if ( $this->settings->get_params( 'sc_pd_img_box_shadow' ) ) {
			$css .= '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-products .vi-wcaio-sidebar-cart-pd-img-wrap img{
                box-shadow: 0 4px 10px rgba(0,0,0,0.07);
            }';
		}
		$css .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-content-wrap' ),
			array( 'sc_radius' ),
			array( 'border-radius' ),
			array( 'px' )
		);
		$css .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-header-wrap' ),
			array( 'sc_header_bg_color', 'sc_header_border_style', 'sc_header_border_color' ),
			array( 'background', 'border-style', 'border-color' ),
			array( '', '', '' )
		);
		$css .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-header-wrap .vi-wcaio-sidebar-cart-header-title-wrap' ),
			array( 'sc_header_title_color' ),
			array( 'color' ),
			array( '' )
		);
		$css .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-header-wrap .vi-wcaio-sidebar-cart-header-coupon-wrap .vi-wcaio-coupon-code' ),
			array( 'sc_header_coupon_input_radius' ),
			array( 'border-radius' ),
			array( 'px' )
		);
		$css .= $frontend::add_inline_style(
			array(
			        '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-header-wrap .vi-wcaio-sidebar-cart-header-coupon-wrap button.vi-wcaio-bt-coupon-code' ,
			        '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-header-wrap .vi-wcaio-sidebar-cart-header-coupon-wrap .vi-wcaio-bt-coupon-code.button'
            ),
			array( 'sc_header_coupon_button_bg_color', 'sc_header_coupon_button_color', 'sc_header_coupon_button_border_radius' ),
			array( 'background', 'color', 'border-radius' ),
			array( '', '', 'px' )
		);
		$css .= $frontend::add_inline_style(
			array(
			        '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-header-wrap .vi-wcaio-sidebar-cart-header-coupon-wrap button.vi-wcaio-bt-coupon-code:hover',
			        '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-header-wrap .vi-wcaio-sidebar-cart-header-coupon-wrap .vi-wcaio-bt-coupon-code.button:hover'
            ),
			array( 'sc_header_coupon_button_bg_color_hover', 'sc_header_coupon_button_color_hover' ),
			array( 'background', 'color' ),
			array( '', '' )
		);
		$css .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-footer-wrap' ),
			array( 'sc_footer_bg_color', 'sc_footer_border_type', 'sc_footer_border_color' ),
			array( 'background', 'border-style', 'border-color' ),
			array( '', '', '' )
		);
		$css .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-footer-wrap .vi-wcaio-sidebar-cart-footer-cart_total > div:nth-child(1)' ),
			array( 'sc_footer_cart_total_color' ),
			array( 'color' ),
			array( '' )
		);
		$css .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-footer-wrap .vi-wcaio-sidebar-cart-footer-cart_total > div:nth-child(2)' ),
			array( 'sc_footer_cart_total_color1' ),
			array( 'color' ),
			array( '' )
		);
		$css .= $frontend::add_inline_style(
			array(
			        '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-footer-wrap button.vi-wcaio-sidebar-cart-bt-nav' ,
			        '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-footer-wrap .vi-wcaio-sidebar-cart-bt-nav.button'
            ),
			array( 'sc_footer_button_bg_color', 'sc_footer_button_color', 'sc_footer_button_border_radius' ),
			array( 'background', 'color', 'border-radius' ),
			array( '', '', 'px' )
		);
		$css .= $frontend::add_inline_style(
			array(
			        '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-footer-wrap button.vi-wcaio-sidebar-cart-bt-nav:hover' ,
			        '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-footer-wrap .vi-wcaio-sidebar-cart-bt-nav.button:hover'
            ),
			array( 'sc_footer_button_hover_bg_color', 'sc_footer_button_hover_color' ),
			array( 'background', 'color' ),
			array( '', '' )
		);
		$css .= $frontend::add_inline_style(
			array(
			        '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-footer-wrap button.vi-wcaio-sidebar-cart-bt-update',
			        '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-footer-wrap .vi-wcaio-sidebar-cart-bt-update.button'
            ),
			array( 'sc_footer_bt_update_bg_color', 'sc_footer_bt_update_color', 'sc_footer_bt_update_border_radius' ),
			array( 'background', 'color', 'border-radius' ),
			array( '', '', 'px' )
		);
		$css .= $frontend::add_inline_style(
			array(
			        '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-footer-wrap button.vi-wcaio-sidebar-cart-bt-update:hover' ,
			        '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-footer-wrap .vi-wcaio-sidebar-cart-bt-update.button:hover'
            ),
			array( 'sc_footer_bt_update_hover_bg_color', 'sc_footer_bt_update_hover_color' ),
			array( 'background', 'color' ),
			array( '', '' )
		);
		$css .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-footer-wrap .vi-wcaio-sidebar-cart-footer-pd-plus-title' ),
			array( 'sc_footer_pd_plus_color' ),
			array( 'color' ),
			array( '' )
		);
		$css .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-products-wrap' ),
			array( 'sc_pd_bg_color' ),
			array( 'background' ),
			array( '' )
		);
		$css .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-products .vi-wcaio-sidebar-cart-pd-img-wrap img' ),
			array( 'sc_pd_img_border_radius' ),
			array( 'border-radius' ),
			array( 'px' )
		);
		$css .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-products .vi-wcaio-sidebar-cart-pd-info-wrap .vi-wcaio-sidebar-cart-pd-name-wrap .vi-wcaio-sidebar-cart-pd-name, .vi-wcaio-sidebar-cart-footer-pd-name *' ),
			array( 'sc_pd_name_color' ),
			array( 'color' ),
			array( '' )
		);
		$css .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-products .vi-wcaio-sidebar-cart-pd-info-wrap .vi-wcaio-sidebar-cart-pd-name-wrap .vi-wcaio-sidebar-cart-pd-name:hover, .vi-wcaio-sidebar-cart-footer-pd-name *:hover' ),
			array( 'sc_pd_name_hover_color' ),
			array( 'color' ),
			array( '' )
		);
		$css .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-products .vi-wcaio-sidebar-cart-pd-info-wrap .vi-wcaio-sidebar-cart-pd-price *, .vi-wcaio-sidebar-cart-footer-pd-price *' ),
			array( 'sc_pd_price_color' ),
			array( 'color' ),
			array( '' )
		);
		if ( $sc_pd_qty_border_color = $this->settings->get_params( 'sc_pd_qty_border_color' ) ) {
			$css .= '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-products .vi-wcaio-sidebar-cart-pd-desc .vi-wcaio-sidebar-cart-pd-quantity{
                 border: 1px solid ' . $sc_pd_qty_border_color . ' ;
            }';
			$css .= '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-products .vi-wcaio-sidebar-cart-pd-desc .vi_wcaio_minus{
                 border-right: 1px solid ' . $sc_pd_qty_border_color . ' ;
            }';
			$css .= '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-products .vi-wcaio-sidebar-cart-pd-desc .vi_wcaio_plus{
                 border-left: 1px solid ' . $sc_pd_qty_border_color . ' ;
            }';
			$css .= '.vi-wcaio-sidebar-cart.vi-wcaio-sidebar-cart-rtl .vi-wcaio-sidebar-cart-products .vi-wcaio-sidebar-cart-pd-desc .vi_wcaio_minus{
			     border-right: unset;
                 border-left: 1px solid ' . $sc_pd_qty_border_color . ' ;
            }';
			$css .= '.vi-wcaio-sidebar-cart.vi-wcaio-sidebar-cart-rtl .vi-wcaio-sidebar-cart-products .vi-wcaio-sidebar-cart-pd-desc .vi_wcaio_plus{
			     border-left: unset;
                 border-right: 1px solid ' . $sc_pd_qty_border_color . ' ;
            }';
		}
		$css .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-products .vi-wcaio-sidebar-cart-pd-desc .vi-wcaio-sidebar-cart-pd-quantity' ),
			array( 'sc_pd_qty_border_radius' ),
			array( 'border-radius' ),
			array( 'px' )
		);
		$css .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-products .vi-wcaio-sidebar-cart-pd-remove-wrap i' ),
			array( 'sc_pd_delete_icon_color' ),
			array( 'color' ),
			array( '' )
		);
		$css .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-products .vi-wcaio-sidebar-cart-pd-remove-wrap i:before' ),
			array( 'sc_pd_delete_icon_font_size' ),
			array( 'font-size' ),
			array( 'px' )
		);
		$css .= $frontend::add_inline_style(
			array( '.vi-wcaio-sidebar-cart .vi-wcaio-sidebar-cart-products .vi-wcaio-sidebar-cart-pd-remove-wrap i:hover' ),
			array( 'sc_pd_delete_icon_hover_color' ),
			array( 'color' ),
			array( '' )
		);
		$css .= $frontend::add_inline_style(
			array(
			        '.vi-wcaio-sidebar-cart button.vi-wcaio-pd_plus-product-bt-atc' ,
			        '.vi-wcaio-sidebar-cart .button.vi-wcaio-pd_plus-product-bt-atc' ,
            ),
			array( 'sc_footer_pd_plus_bt_atc_bg_color', 'sc_footer_pd_plus_bt_atc_color' ),
			array( 'background', 'color' ),
			array( '', '' )
		);
		$css .= $frontend::add_inline_style(
			array(
			        '.vi-wcaio-sidebar-cart button.vi-wcaio-pd_plus-product-bt-atc:hover',
			        '.vi-wcaio-sidebar-cart .button.vi-wcaio-pd_plus-product-bt-atc:hover',
            ),
			array( 'sc_footer_pd_plus_bt_atc_hover_bg_color', 'sc_footer_pd_plus_bt_atc_hover_color' ),
			array( 'background', 'color' ),
			array( '', '' )
		);
		$css = str_replace( array( "\r", "\n", '\r', '\n' ), ' ', $css );
		return $css;
	}
	public function frontend_html() {
		$class           = array(
			'vi-wcaio-sidebar-cart',
			'vi-wcaio-sidebar-cart-' . $sc_display_type = $this->get_params( 'sc_display_type' ),
			'vi-wcaio-sidebar-cart-' . $sc_position = $this->get_params( 'sc_position' ),
		);
		$class[]         = is_rtl() ? 'vi-wcaio-sidebar-cart-rtl' : '';
		$sc_empty_enable = $this->settings->get_params( 'sc_empty_enable' );
		if ( ! $this->is_customize ) {
			$class[] = ! $sc_empty_enable && WC()->cart->is_empty() ? 'vi-wcaio-disabled' : '';
		}
		$class = trim( implode( ' ', $class ) );
		?>
		<div class="vi-wcaio-sidebar-cart-wrap" data-empty_enable="<?php echo esc_attr( $sc_empty_enable ?: '' ); ?>"
		     data-effect_after_atc="<?php echo esc_attr( $this->settings->get_params( 'sc_effect_after_atc' ) ?: '' ); ?>"
		     data-fly_to_cart="<?php echo esc_attr( $this->settings->get_params( 'sc_fly_to_cart' ) ?: '' ); ?>">
			<div class="vi-wcaio-sidebar-cart-overlay vi-wcaio-disabled"></div>
			<div class="<?php echo esc_attr( $class ); ?>" data-type="<?php echo esc_attr( $sc_display_type ); ?>" data-old_position=""
			     data-position="<?php echo esc_attr( $sc_position ); ?>"
			     data-effect="<?php echo esc_attr( $this->settings->get_params( 'sc_trigger_style' ) ); ?>">
				<?php
				do_action( 'vi_wcaio_get_sidebar_cart_content' );
				?>
			</div>
		</div>
		<?php
	}
	public function get_sidebar_cart_content() {
		$class   = array(
			'vi-wcaio-sidebar-cart-content-close',
			'vi-wcaio-sidebar-cart-content-wrap',
		);
		$class[] = $this->sc_checkout || $this->is_customize ? 'vi-wcaio-sidebar-cart-content-wrap-checkout' : '';
		$class[] = $this->is_customize ? 'vi-wcaio-sidebar-cart-content-wrap-customize' : '';
		$class[] = is_user_logged_in() ? 'vi-wcaio-sidebar-cart-content-wrap-logged' : '';
		$class   = trim( implode( ' ', $class ) );
		$wc_cart = WC()->cart;
		do_action( 'vi_wcaio_before_mini_cart' );
		$language = $this->language ?? '';
		?>
		<div class="<?php echo esc_attr( $class ); ?>">
			<div class="vi-wcaio-sidebar-cart-header-wrap">
				<div class="vi-wcaio-sidebar-cart-header-title-wrap">
					<?php echo wp_kses_post( $this->get_params( 'sc_header_title', $language ) ); ?>
				</div>
				<?php
				if ( $this->is_customize || $this->settings->get_params( 'sc_header_coupon_enable' ) ) {
					?>
					<div class="vi-wcaio-sidebar-cart-header-coupon-wrap">
						<?php
						if ( wc_coupons_enabled() ) {
							$coupon_applied = $wc_cart->get_applied_coupons();
							if ( ! empty( $coupon_applied ) ) {
								$coupon_applied_name = $coupon_applied[ count( $coupon_applied ) - 1 ];
							}
						}
						?>
						<input type="text" name="coupon_code" id="coupon_code" class="vi-wcaio-coupon-code"
						       placeholder="<?php esc_attr_e( 'Coupon code', 'woocommerce-cart-all-in-one' ); ?>"
						       value="<?php echo esc_attr( $coupon_applied_name ?? '' ); ?>">
						<button type="submit" class="button vi-wcaio-bt-coupon-code" name="apply_coupon">
							<?php echo sprintf( '%s', apply_filters( 'vi_wcaio_get_bt_coupon_text', esc_html__( 'Apply', 'woocommerce-cart-all-in-one' ) ) ); ?>
						</button>
					</div>
					<?php
				}
				?>
				<div class="vi-wcaio-sidebar-cart-close-wrap">
					<i class="vi_wcaio_cart_icon-clear-button"></i>
				</div>
			</div>
			<div class="vi-wcaio-sidebar-cart-content-wrap1 vi-wcaio-sidebar-cart-products-wrap">
				<ul class="vi-wcaio-sidebar-cart-products">
					<?php
					$this->get_sidebar_content_pd_html( $wc_cart );
					?>
				</ul>
			</div>
			<?php
			if ( $this->sc_checkout || $this->is_customize ) {
				$sc_checkout_keyboard_nav = $this->settings->get_params( 'sc_checkout_keyboard_nav' ) ?: '';
				?>
				<div class="vi-wcaio-sidebar-cart-content-wrap1 vi-wcaio-sidebar-cart-checkout-wrap vi-wcaio-disabled" data-use_keyboard="<?php echo esc_attr( $sc_checkout_keyboard_nav ); ?>">
					<?php
					if ( $this->is_customize || ! WC()->cart->is_empty() ) {
						wc_get_template( 'form-checkout.php', array( 'checkout' => WC()->checkout(), 'language' => $language ), '', VIWCAIO_CART_ALL_IN_ONE_TEMPLATES );
					}
					?>
				</div>
				<?php
			}
			?>
			<div class="vi-wcaio-sidebar-cart-footer-wrap">
				<div class="vi-wcaio-sidebar-cart-footer vi-wcaio-sidebar-cart-footer-products">
					<?php
					$sc_footer_cart_total       = $this->settings->get_params( 'sc_footer_cart_total' ) ?: 'total';
					$sc_footer_cart_total_title = $this->settings->get_params( 'sc_footer_cart_total_text', $language );
					$sc_footer_button           = $this->get_params( 'sc_footer_button' ) ?: 'cart';
					if ( $this->is_customize ) {
						?>
						<div class="vi-wcaio-sidebar-cart-footer-cart_total-wrap">
							<div class="vi-wcaio-sidebar-cart-footer-cart_total vi-wcaio-sidebar-cart-footer-total<?php echo $sc_footer_cart_total === 'total' ? '' : esc_attr( ' vi-wcaio-disabled' ); ?>"
							     data-cart_total="<?php echo esc_attr( $cart_total = $wc_cart->get_total() ); ?>">
								<div class="vi-wcaio-sidebar-cart-footer-cart_total-title"><?php echo wp_kses_post( $sc_footer_cart_total_title ); ?></div>
								<div class="vi-wcaio-sidebar-cart-footer-cart_total1">
									<?php echo wp_kses_post( $cart_total ); ?>
								</div>
							</div>
							<div class="vi-wcaio-sidebar-cart-footer-cart_total vi-wcaio-sidebar-cart-footer-subtotal<?php echo $sc_footer_cart_total !== 'total' ? '' : esc_attr( ' vi-wcaio-disabled' ); ?>"
							     data-cart_total="<?php echo esc_attr( $cart_subtotal = $wc_cart->get_cart_subtotal() ); ?>">
								<div class="vi-wcaio-sidebar-cart-footer-cart_total-title"><?php echo wp_kses_post( $sc_footer_cart_total_title ); ?></div>
								<div class="vi-wcaio-sidebar-cart-footer-cart_total1">
									<?php echo wp_kses_post( $cart_subtotal ); ?>
								</div>
							</div>
						</div>
						<div class="vi-wcaio-sidebar-cart-footer-action">
							<button class="vi-wcaio-sidebar-cart-bt vi-wcaio-sidebar-cart-bt-update button">
								<?php echo wp_kses_post( apply_filters( 'vi_wcaio_get_bt_update_text', __( 'Update Cart', 'woocommerce-cart-all-in-one' ) ) ); ?>
							</button>
							<a href="<?php echo esc_attr( esc_url( get_permalink( wc_get_page_id( 'cart' ) ) ) ); ?>"
							   class="button vi-wcaio-sidebar-cart-bt vi-wcaio-sidebar-cart-bt-nav vi-wcaio-sidebar-cart-bt-nav-cart<?php echo $sc_footer_button === 'cart' ? '' : esc_attr( ' vi-wcaio-disabled' ); ?>">
								<?php echo wp_kses_post( $this->get_params( 'sc_footer_bt_cart_text', $language ) ); ?>
							</a>
							<a href="#" data-href="<?php echo esc_attr( esc_url( get_permalink( wc_get_page_id( 'checkout' ) ) ) ); ?>"
							   class="button vi-wcaio-sidebar-cart-bt vi-wcaio-sidebar-cart-bt-nav vi-wcaio-sidebar-cart-bt-nav-checkout<?php echo $sc_footer_button === 'checkout' ? '' : esc_attr( ' vi-wcaio-disabled' ); ?>">
								<?php echo wp_kses_post( $this->get_params( 'sc_footer_bt_checkout_text', $language ) ); ?>
							</a>
						</div>
						<?php
					} else {
						?>
						<div class="vi-wcaio-sidebar-cart-footer-cart_total-wrap">
							<div class="vi-wcaio-sidebar-cart-footer-cart_total vi-wcaio-sidebar-cart-footer-<?php echo esc_attr( $sc_footer_cart_total ); ?>">
								<div class="vi-wcaio-sidebar-cart-footer-cart_total-title"><?php echo wp_kses_post( $sc_footer_cart_total_title ); ?></div>
								<div class="vi-wcaio-sidebar-cart-footer-cart_total1">
									<?php echo $sc_footer_cart_total === 'total' ? wp_kses_post( $wc_cart->get_cart_total() ) : wp_kses_post( $wc_cart->get_cart_subtotal() ); ?>
								</div>
							</div>
						</div>
						<div class="vi-wcaio-sidebar-cart-footer-action">
							<button class="vi-wcaio-sidebar-cart-bt vi-wcaio-sidebar-cart-bt-update vi-wcaio-disabled button">
								<?php echo wp_kses_post( apply_filters( 'vi_wcaio_get_bt_update_text', __( 'Update Cart', 'woocommerce-cart-all-in-one' ) ) ); ?>
							</button>
							<?php
							if ( $this->sc_checkout ) {
								?>
								<button class="button vi-wcaio-sidebar-cart-bt vi-wcaio-sidebar-cart-bt-nav vi-wcaio-sidebar-cart-bt-nav-checkout">
									<?php echo wp_kses_post( $this->settings->get_params( 'sc_footer_bt_checkout_text', $language ) ); ?>
								</button>
								<?php
							} else {
								?>
								<a href="<?php echo esc_attr( esc_url( get_permalink( wc_get_page_id( $sc_footer_button ) ) ) ); ?>"
								   class="button vi-wcaio-sidebar-cart-bt vi-wcaio-sidebar-cart-bt-nav vi-wcaio-sidebar-cart-bt-nav-<?php echo esc_attr( $sc_footer_button ); ?>">
									<?php echo wp_kses_post( $this->settings->get_params( 'sc_footer_bt_' . $sc_footer_button . '_text', $language ) ); ?>
								</a>
								<?php
							}
							?>
						</div>
						<?php
					}
					?>
				</div>
				<?php
				if ( $this->sc_checkout || $this->is_customize ) {
					$place_order_text = $this->get_params( 'sc_checkout_bt_place_order_title', $language );
					$bt_next_text     = $this->get_params( 'sc_checkout_bt_next_title', $language );
					$bt_pre_text      = $this->get_params( 'sc_checkout_bt_pre_title', $language );
					?>
					<div class="vi-wcaio-sidebar-cart-footer vi-wcaio-sidebar-cart-footer-checkout vi-wcaio-disabled">
						<button class="vi-wcaio-sidebar-cart-bt vi-wcaio-sidebar-cart-bt-checkout vi-wcaio-sidebar-cart-bt-checkout-place_order button vi-wcaio-disabled"
						        data-place_order_text="<?php echo esc_attr( $place_order_text ); ?>">
							<?php echo wp_kses_post( $place_order_text ); ?>
						</button>
						<button class="vi-wcaio-sidebar-cart-bt vi-wcaio-sidebar-cart-bt-checkout vi-wcaio-sidebar-cart-bt-checkout-nav vi-wcaio-sidebar-cart-bt-checkout-next button vi-wcaio-disabled"
						        data-next_text="<?php echo esc_attr( $bt_next_text ); ?>">
							<?php echo wp_kses_post( $bt_next_text ); ?>
						</button>
						<button class="vi-wcaio-sidebar-cart-bt vi-wcaio-sidebar-cart-bt-checkout vi-wcaio-sidebar-cart-bt-checkout-nav vi-wcaio-sidebar-cart-bt-checkout-back button vi-wcaio-disabled"
						        data-pre_text="<?php echo esc_attr( $bt_pre_text ); ?>">
							<?php echo wp_kses_post( $bt_pre_text ); ?>
						</button>
						<?php
						if ( $this->settings->get_params( 'sc_checkout_bt_btc_enable' ) || $this->is_customize ) {
							$sc_checkout_bt_btc_title = $this->get_params( 'sc_checkout_bt_btc_title', $language );
							$back_icon_class          = $this->settings->get_class_icon( $this->get_params( 'sc_checkout_bt_btc_icon' ), 'back_icons' ) ?: '';
							$sc_checkout_bt_btc_title = str_replace( '{back_icon}', '<i class="vi-wcaio-sc-checkout-bt-btc-back_icons ' . $back_icon_class . '"></i>', $sc_checkout_bt_btc_title );
							?>
							<button class="vi-wcaio-sidebar-cart-bt vi-wcaio-sidebar-cart-bt-checkout vi-wcaio-sidebar-cart-bt-checkout-cancel button">
								<?php echo wp_kses_post( $sc_checkout_bt_btc_title ); ?>
							</button>
							<?php
						}
						?>
					</div>
					<?php
				}
				?>
				<div class="vi-wcaio-sidebar-cart-footer-message-wrap">
					<?php
					self::get_sc_footer_message_html( $this->get_params( 'sc_footer_message' ), $language );
					?>
				</div>
			</div>
			<div class="vi-wcaio-sidebar-cart-loading-wrap vi-wcaio-disabled">
				<?php
				$sc_loading = $this->settings->get_params( 'sc_loading' );
				if ( $this->is_customize ) {
					$loading = array(
						'default',
						'dual_ring',
						'animation_face_1',
						'animation_face_2',
						'ring',
						'roller',
						'loader_balls_1',
						'loader_balls_2',
						'loader_balls_3',
						'ripple',
						'spinner'
					);
					foreach ( $loading as $item ) {
						$this->get_sidebar_loading( $item );
					}
				} elseif ( $sc_loading ) {
					$this->get_sidebar_loading( $sc_loading );
				}
				?>
			</div>
		</div>
		<?php
		do_action( 'vi_wcaio_after_mini_cart' );
	}
	public function get_sidebar_loading( $type ) {
		if ( ! $type ) {
			return;
		}
		$class   = array(
			'vi-wcaio-sidebar-cart-loading vi-wcaio-sidebar-cart-loading-' . $type
		);
		$class[] = $this->is_customize ? 'vi-wcaio-disabled' : '';
		$class   = trim( implode( ' ', $class ) );
		switch ( $type ) {
			case 'spinner':
			case 'default':
				?>
				<div class="<?php echo esc_attr( $class ); ?>">
					<div></div>
					<div></div>
					<div></div>
					<div></div>
					<div></div>
					<div></div>
					<div></div>
					<div></div>
					<div></div>
					<div></div>
					<div></div>
					<div></div>
				</div>
				<?php
				break;
			case 'dual_ring':
				?>
				<div class="<?php echo esc_attr( $class ); ?>"></div>
				<?php
				break;
			case 'animation_face_1':
				?>
			<div class="<?php echo esc_attr( $class ); ?>">
					<div></div>
					<div></div>
					<div></div></div><?php
				break;
			case 'animation_face_2':
			case 'ring':
				?>
			<div class="<?php echo esc_attr( $class ); ?>">
					<div></div>
					<div></div>
					<div></div>
					<div></div></div><?php
				break;
			case 'roller':
				?>
				<div class="<?php echo esc_attr( $class ); ?>">
					<div></div>
					<div></div>
					<div></div>
					<div></div>
					<div></div>
					<div></div>
					<div></div>
					<div></div>
				</div>
				<?php
				break;
			case 'loader_balls_1':
				?>
				<div class="<?php echo esc_attr( $class ); ?>">
					<div></div>
					<div></div>
					<div></div>
					<div></div>
				</div>
				<?php
				break;
			case 'loader_balls_2':
			case 'loader_balls_3':
				?>
				<div class="<?php echo esc_attr( $class ); ?>">
					<div></div>
					<div></div>
					<div></div>
				</div>
				<?php
				break;
			case 'ripple':
				?>
				<div class="<?php echo esc_attr( $class ); ?>">
					<div></div>
					<div></div>
				</div>
				<?php
				break;
		}
	}
	public static function get_sidebar_content_pd_html( $wc_cart ) {
		if ( $wc_cart->is_empty() ) {
			echo sprintf( '<li class="vi-wcaio-sidebar-cart-pd-empty">%s</li>',
				apply_filters( 'vi_wcaio_get_cart_empty_text', esc_html__( 'No products in the cart.', 'woocommerce-cart-all-in-one' ) ) );
		} else {
			$settings          = new VIWCAIO_CART_ALL_IN_ONE_DATA();
			$delete_icon       = $settings->get_params( 'sc_pd_delete_icon' );
			$delete_icon_class = $settings->get_class_icon( $delete_icon, 'delete_icons' );
			foreach ( $wc_cart->get_cart() as $cart_item_key => $cart_item ) {
				$product    = apply_filters( 'woocommerce_cart_item_product', $cart_item['data'], $cart_item, $cart_item_key );
				$product_id = apply_filters( 'woocommerce_cart_item_product_id', $cart_item['product_id'], $cart_item, $cart_item_key );
				if ( $product && $product->exists() && $cart_item['quantity'] > 0 && apply_filters( 'woocommerce_cart_item_visible', true, $cart_item, $cart_item_key ) ) {
					$product_permalink = apply_filters( 'woocommerce_cart_item_permalink', $product->is_visible() ? $product->get_permalink( $cart_item ) : '', $cart_item, $cart_item_key );
					$product_thumbnail = apply_filters( 'woocommerce_cart_item_thumbnail', $product->get_image(), $cart_item, $cart_item_key );
					?>
					<li class="vi-wcaio-sidebar-cart-pd-wrap" data-cart_item_key="<?php echo esc_attr( $cart_item_key ); ?>" data-product_id="<?php echo esc_attr( $product_id ); ?>">
						<div class="vi-wcaio-sidebar-cart-pd-img-wrap">
							<?php
							echo $product_permalink ? sprintf( '<a href="%s">%s</a>', esc_url( $product_permalink ), $product_thumbnail ) : wp_kses_post( $product_thumbnail );
							?>
						</div>
						<div class="vi-wcaio-sidebar-cart-pd-info-wrap">
							<div class="vi-wcaio-sidebar-cart-pd-name-wrap">
								<?php
								if ( ! $product_permalink ) {
									echo wp_kses_post( apply_filters( 'woocommerce_cart_item_name', sprintf( '<div class="vi-wcaio-sidebar-cart-pd-name">%s</div>', $product->get_name() ), $cart_item, $cart_item_key ) );
								} else {
									echo wp_kses_post( apply_filters( 'woocommerce_cart_item_name', sprintf( '<a href="%s" class="vi-wcaio-sidebar-cart-pd-name">%s</a>', esc_url( $product_permalink ), $product->get_name() ), $cart_item, $cart_item_key ) );
								}
								?>
								<div class="vi-wcaio-sidebar-cart-pd-remove-wrap">
									<?php
									echo apply_filters( 'vi_wcaio_mini_cart_pd_remove',
										sprintf( '<a href="%s" class="vi-wcaio-sidebar-cart-pd-remove" aria-label="%s" data-product_id="%s" data-cart_item_key="%s" data-product_sku="%s"><i class="%s"></i></a>',
											esc_url( wc_get_cart_remove_url( $cart_item_key ) ),
											esc_html__( 'Remove this item', 'woocommerce-cart-all-in-one' ),
											esc_attr( $product_id ),
											esc_attr( $cart_item_key ),
											esc_attr( $product->get_sku() ),
											$delete_icon_class
										)
										, $cart_item, $cart_item_key );
									?>
								</div>
							</div>
							<div class="vi-wcaio-sidebar-cart-pd-meta">
								<?php echo wp_kses_post( wc_get_formatted_cart_item_data( $cart_item ) ); ?>
							</div>
							<div class="vi-wcaio-sidebar-cart-pd-desc">
								<?php
								if ( $product->is_sold_individually() ) {
									echo apply_filters( 'vi_wcaio_mini_cart_pd_qty',
										sprintf( '<div class="vi-wcaio-sidebar-cart-pd-quantity vi-wcaio-hidden"><input type="hidden" name="viwcaio_cart[%s][qty]" value="1"></div>', $cart_item_key ),
										$cart_item_key, $cart_item
									);
								} else {
									$max_value = $product->get_max_purchase_quantity();
									$max_value = ( $max_value < 0 ) ? 99999 : $max_value;
									echo apply_filters( 'vi_wcaio_mini_cart_pd_qty',
										sprintf( '<div class="vi-wcaio-sidebar-cart-pd-quantity"><span class="vi_wcaio_change_qty vi_wcaio_minus">-</span><input type="number" name="viwcaio_cart[%s][qty]" value="%s" step="1" min="0" max="%s" class="vi_wcaio_qty"><span class="vi_wcaio_change_qty vi_wcaio_plus">+</span></div>',
											$cart_item_key,
											esc_attr( $cart_item['quantity'] ),
											esc_attr( $max_value )
										),
										$cart_item_key, $cart_item
									);
								}
								?>
								<div class="vi-wcaio-sidebar-cart-pd-price">
									<?php
									echo wp_kses_post( apply_filters( 'woocommerce_cart_item_price', $wc_cart->get_product_price( $product ), $cart_item, $cart_item_key ) );
									?>
								</div>
							</div>
						</div>
					</li>
					<?php
				}
			}
		}
	}
	public static function get_sc_footer_message_html( $text, $language = '' ) {
		if ( ! $text ) {
			return '';
		}
		$shortcodes = array();
		preg_match_all( '/' . get_shortcode_regex() . '/', $text, $matches, PREG_SET_ORDER );
		if ( ! empty( $matches ) ) {
			foreach ( $matches as $shortcode ) {
				$shortcodes[] = $shortcode[0];
			}
		}
		if ( count( $shortcodes ) ) {
			foreach ( $shortcodes as $shortcode ) {
				$text = str_replace( $shortcode, do_shortcode( $shortcode ), $text );
			}
		}
		$text = str_replace( '{product_plus}', self::get_product_plus( $language ), $text );
		echo wp_kses( $text, VIWCAIO_CART_ALL_IN_ONE_DATA::extend_post_allowed_html() );
	}
	public static function get_product_plus( $language = '' ) {
		$settings           = new VIWCAIO_CART_ALL_IN_ONE_DATA();
		$sc_footer_pd_plus  = $settings->get_params( 'sc_footer_pd_plus' );
		$product_plus_limit = $settings->get_params( 'sc_footer_pd_plus_limit' );
		$out_of_stock       = $settings->get_params( 'sc_footer_pd_plus_out_of_stock' );
		$product_plus       = self::get_sidebar_pd_plus( $sc_footer_pd_plus, $product_plus_limit, $out_of_stock );
		if ($language &&  is_plugin_active( 'sitepress-multilingual-cms/sitepress.php' )) {
			$product_plus = self::get_sidebar_pd_plus_wpml($product_plus, $language);
		}
		if ( empty( $product_plus ) || ! is_array( $product_plus ) ) {
			return '';
		}
		ob_start();
		?>
		<div class="vi-wcaio-sidebar-cart-footer-pd-wrap-wrap vi-wcaio-sidebar-cart-footer-pd-<?php echo esc_attr( $sc_footer_pd_plus ); ?>">
			<div class="vi-wcaio-sidebar-cart-footer-pd-plus-title">
				<?php echo wp_kses_post( $settings->get_params( 'sc_footer_pd_plus_title', $language ) ); ?>
			</div>
			<div class="vi-wcaio-sidebar-cart-footer-pd-wrap">
				<?php
				foreach ( $product_plus as $product_id ) {
					self::get_product_plus_html( $product_id, $language, $settings );
				}
				?>
			</div>
		</div>
		<?php
		$html = ob_get_clean();
		return $html;
	}
	public static function get_product_plus_html( $product_id, $language, $settings ) {
		$settings = $settings ?: new VIWCAIO_CART_ALL_IN_ONE_DATA();
		if ( ! $product_id || ! $product = wc_get_product( $product_id ) ) {
			return;
		}
		$product_permalink = $product->get_permalink();
		$product_name      = $product->get_name();
		$img_url           = wp_get_attachment_image_url( get_post_thumbnail_id( $product_id ), 'woocommerce_gallery_thumbnail' ) ?? wc_placeholder_img_src('woocommerce_gallery_thumbnail');
		?>
		<div class="vi-wcaio-sidebar-cart-footer-pd vi-wcaio-sidebar-cart-footer-pd-type-1">
			<div class="vi-wcaio-sidebar-cart-footer-pd-desc-wrap">
				<div class="vi-wcaio-sidebar-cart-footer-pd-img">
					<?php
					echo $product_permalink ? sprintf( '<a href="%s"><img src="%s" class="vi-wcaio-sidebar-cart-footer-pd-img1"></a>', esc_url( $product_permalink ), esc_url( $img_url ) ) :
						sprintf( '<img src="%s" class="vi-wcaio-sidebar-cart-footer-pd-img1">', esc_url( $img_url ) );
					?>
				</div>
				<div class="vi-wcaio-sidebar-cart-footer-pd-desc">
					<div class="vi-wcaio-sidebar-cart-footer-pd-name">
						<?php
						if ( $product_permalink ) {
							echo sprintf( '<a href="%s">%s</a>', esc_url( $product_permalink ), esc_attr( $product_name ) );
						} else {
							echo wp_kses_post( $product_name );
						}
						?>
					</div>
					<div class="vi-wcaio-sidebar-cart-footer-pd-price">
						<?php echo wp_kses_post( $product->get_price_html() ); ?>
					</div>
				</div>
			</div>
			<div class="vi-wcaio-sidebar-cart-footer-pd-control">
				<?php
				do_action( 'vi_wcaio_sc_pd_plus_' . $product->get_type() . '_atc', $product, $settings, $language );
				?>
			</div>
		</div>
		<?php
	}
	public static function get_sidebar_pd_plus_wpml( $product_plus, $language='' ) {
	    if (!$language || !is_array($product_plus) || empty($product_plus)){
	        return false;
        }
	    $result =array();
	    foreach ($product_plus as $product_id){
	        $result[]=apply_filters( 'wpml_object_id',$product_id, 'product', false, $language );
        }
	    return array_unique($result);
	}
	public static function get_sidebar_pd_plus( $type = '', $limit = 5, $out_of_stock = false ) {
		if ( ! $type || ! $limit ) {
			return false;
		}
		$limit = $limit > 15 ? 15 : $limit;
		$product_visibility_hidden  =apply_filters('vi_wcaio_sc_pd_plus_visibility_hidden',1);
		switch ( $type ) {
			case 'best_selling':
				$args = array(
					'post_type'      => 'product',
					'post_status'    => 'publish',
					'meta_key'       => 'total_sales',
					'orderby'        => 'meta_value_num',
					'order'          => 'DESC',
					'posts_per_page' => $limit
				);
				if ($product_visibility_hidden) {
					$args['tax_query'] = array(
						array(
							'taxonomy' => 'product_visibility',
							'terms'    => array( 'exclude-from-catalog', 'exclude-from-search' ),
							'field'    => 'name',
							'operator' => 'NOT IN'
						)
					);
				}
				if ( ! $out_of_stock ) {
					$args['meta_query'] = array(
						'relation' => 'AND',
						array(
							'key'     => '_stock_status',
							'value'   => 'instock',
							'compare' => 'EQUAL'
						)
					);
				}
				$product_ids = array();
				$the_query   = new WP_Query( $args );
				if ( $the_query->have_posts() ) {
					while ( $the_query->have_posts() ) {
						$the_query->the_post();
						$product_ids[] = get_the_ID();
					}
				}
				wp_reset_postdata();
				break;
			case 'viewed_product':
				$viewed_products = is_active_widget( false, false, 'woocommerce_recently_viewed_products', true ) ? ( $_COOKIE['woocommerce_recently_viewed'] ?? '' ) : '';
				$viewed_products = $viewed_products ?: ( $_COOKIE['viwcaio_recently_viewed'] ?? '' );
				$product_ids_t = $viewed_products ? explode( '|', wp_unslash( $viewed_products ) ) : array();
				if ($product_visibility_hidden){
					$product_ids_t1 = $product_ids_t;
					$product_ids_t =array();
					foreach ( $product_ids_t1 as $id ) {
						$product = wc_get_product( $id );
						if (  $product->get_catalog_visibility() ==='hidden') {
							continue;
						}
						$product_ids_t[] = $id;
					}
                }
				if (empty($product_ids_t)){
				    break;
                }
				if ( ! $out_of_stock ) {
					$product_ids   = array();
					foreach ( $product_ids_t as $id ) {
						if ( ! $limit ) {
							break;
						}
						$product = wc_get_product( $id );
						if ( ! $product->is_in_stock() ) {
							continue;
						}
						$product_ids[] = $id;
					}
				} else {
					$product_ids = $product_ids_t;
					if ( $limit < count( $product_ids_t ) ) {
						$product_ids = array_slice( $product_ids_t, 0, $limit );
					}
				}
				break;
			case 'product_rating':
				$args = array(
					'post_type'      => 'product',
					'meta_key'       => '_wc_average_rating',
					'orderby'        => 'meta_value_num',
					'order'          => 'DESC',
					'posts_per_page' => $limit
				);
				if ($product_visibility_hidden) {
					$args['tax_query'] = array(
						array(
							'taxonomy' => 'product_visibility',
							'terms'    => array( 'exclude-from-catalog', 'exclude-from-search' ),
							'field'    => 'name',
							'operator' => 'NOT IN'
						)
					);
				}
				if ( ! $out_of_stock ) {
					$args['meta_query'] = array(
						'relation' => 'AND',
						array(
							'key'     => '_stock_status',
							'value'   => 'instock',
							'compare' => 'EQUAL'
						)
					);
				}
				$product_ids = array();
				$the_query   = new WP_Query( $args );
				if ( $the_query->have_posts() ) {
					while ( $the_query->have_posts() ) {
						$the_query->the_post();
						$product_ids[] = get_the_ID();
					}
				}
				wp_reset_postdata();
				break;
		}
		return $product_ids ?? false;
	}
	public function get_pd_plus_simple_atc( $product, $settings, $language ) {
		$product_id = $product->get_id();
		?>
		<button type="button" class="vi-wcaio-product-bt-atc vi-wcaio-pd_plus-product-bt-atc button">
			<?php echo wp_kses_post( self::product_get_bt_atc_html( $settings, $language ) ); ?>
		</button>
		<input type="hidden" name="add-to-cart" class="vi-wcaio-add-to-cart" value="<?php echo esc_attr( $product_id ); ?>"/>
		<input type="hidden" name="product_id" class="vi-wcaio-product_id" value="<?php echo esc_attr( $product_id ); ?>"/>
		<?php
	}

	public function get_pd_plus_external_atc( $product, $settings, $language ) {
		?>
		<form class="vi-wcaio-pd_plus-cart-form" action="<?php echo esc_attr( esc_url( $product->add_to_cart_url() ) ); ?>" method="get">
			<button type="submit" class="vi-wcaio-product-bt-atc vi-wcaio-product-bt-not-atc vi-wcaio-product-bt-external vi-wcaio-pd_plus-product-bt-atc vi-wcaio-pd_plus-product-bt-external button">
				<?php echo wp_kses_post( self::product_get_bt_atc_html( $settings, $language ) ); ?>
			</button>
		</form>
		<?php
	}

	public function get_pd_plus_grouped_atc( $product, $settings, $language ) {
		$product_type = $product->get_type();
		$class        = array( 'vi-wcaio-product-bt-atc vi-wcaio-product-bt-not-atc vi-wcaio-pd_plus-product-bt-atc button' );
		$class[]      = 'vi-wcaio-product-bt-' . $product_type;
		if ( $product_type === 'variable' && $this->settings->get_params( 'ajax_atc_pd_variable' ) ) {
			$class[]    = 'vi-wcaio-loop-variable-bt-atc';
			$data_pd_id = 'data-product_id="' . $product->get_id() . '"';
			if ( ! wp_style_is( 'vi-wcaio-variable-atc', 'enqueued' ) ) {
				wp_enqueue_style( 'vi-wcaio-variable-atc' );
				wp_enqueue_style( 'vi-wcaio-nav-icons' );
			}
			if ( ! wp_script_is( 'vi-wcaio-variable-atc', 'enqueued' ) ) {
				wp_enqueue_script( 'vi-wcaio-variable-atc' );
				wp_enqueue_script( 'vi-wcaio-ajax-atc' );
				wp_enqueue_script( 'vi-wcaio-frontend-swatches' );
			}
		}
		$class = trim( implode( ' ', $class ) );
		echo sprintf( '<a href="%s" class="%s" %s >%s</a>',
			esc_attr( esc_url( $product->get_permalink() ) ), $class, $data_pd_id ?? '',
			self::product_get_bt_atc_html( $settings, $language )
		);
	}
	public static function product_get_bt_atc_html( $settings, $language ) {
		if ( ! $settings ) {
			return '';
		}
		$html            = $settings->get_params( 'sc_footer_pd_plus_bt_atc_title', $language );
		$cart_icon_class = $settings->get_class_icon( $settings->get_params( 'sc_footer_pd_plus_bt_atc_cart_icon' ), 'cart_icons_atc' ) ?: '';
		$html            = str_replace( '{cart_icon}', '<i class="vi-wcaio-pd_plus-bt-atc-cart_icons ' . $cart_icon_class . '"></i>', $html );

		return $html;
	}
	public function init_payment_gateways() {
		if ( is_checkout() || is_cart() ) {
			return;
		}
		if ( ! $this->assign_page() ) {
			return;
		}
		// Ensure gateways and shipping methods are loaded early.
		WC()->payment_gateways();
		WC()->shipping();
	}
	public function add_filter_is_checkout() {
		if ( is_checkout() || is_cart()) {
			return;
		}
		if ( ! $this->assign_page() ) {
			return;
		}
		$filters = array(
			'woocommerce_is_checkout' => 'viwcaio_is_checkout',
			'viwcuf_ob_enable'        => 'viwcaio_is_not_checkout',
			'viwcuf_us_enable'        => 'viwcaio_is_not_checkout',
		);
		foreach ( $filters as $k => $v ) {
			add_filter( $k, array( 'VIWCAIO_CART_ALL_IN_ONE_Frontend_Form_Checkout', $v ), PHP_INT_MAX, 1 );
		}
	}
	public function remove_filter_is_checkout() {
		if ( ! $this->assign_page() ) {
			return;
		}
		$filters = array(
			'woocommerce_is_checkout' => 'viwcaio_is_checkout',
			'viwcuf_ob_enable'        => 'viwcaio_is_not_checkout',
			'viwcuf_us_enable'        => 'viwcaio_is_not_checkout',
		);
		foreach ( $filters as $k => $v ) {
			remove_filter( $k, array( 'VIWCAIO_CART_ALL_IN_ONE_Frontend_Form_Checkout', $v ), PHP_INT_MAX, 1 );
		}
	}
	private function get_params( $name = '', $language = '' ) {
		if ( $this->customize_data && $name && $setting = $this->customize_data->get_setting( 'woo_cart_all_in_one_params[' . $name . ']' ) ) {
			return $this->customize_data->post_value( $setting, $this->settings->get_params( $name ) );
		} else {
			return $this->settings->get_params( $name, $language );
		}
	}
	public function assign_page() {
		if ( ! $this->settings->enable( 'sc_' ) ) {
			return false;
		}
		$assign_page = $this->settings->get_params( 'sc_assign_page' );
		if ( $assign_page ) {
			if ( stristr( $assign_page, "return" ) === false ) {
				$assign_page = "return (" . $assign_page . ");";
			}
			if ( ! eval( $assign_page ) ) {
				return false;
			}
		}
		return true;
	}
}